org.apache.xml.dtm.ref

## Class DTMChildIterNodeList

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMNodeListBase
  - - org.apache.xml.dtm.ref.DTMChildIterNodeList

- All Implemented Interfaces:
    org.w3c.dom.NodeList

      public class DTMChildIterNodeList
      extends DTMNodeListBase

  `DTMNodeList` gives us an implementation of the DOM's NodeList interface wrapped around a DTM Iterator. The author considers this something of an abominations, since NodeList was not intended to be a general purpose "list of nodes" API and is generally considered by the DOM WG to have be a mistake... but I'm told that some of the XPath/XSLT folks say they must have this solution. Please note that this is not necessarily equivlaent to a DOM NodeList operating over the same document. In particular:
  - If there are several Text nodes in logical succession (ie, across CDATASection and EntityReference boundaries), we will return only the first; the caller is responsible for stepping through them. (%REVIEW% Provide a convenience routine here to assist, pending proposed DOM Level 3 getAdjacentText() operation?)
  - Since the whole XPath/XSLT architecture assumes that the source document is not altered while we're working with it, we do not promise to implement the DOM NodeList's "live view" response to document mutation.

  State: In progress!!

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DTMChildIterNodeList(DTM parentDTM, int parentHandle)` Public constructor: Create a NodeList to support DTMNodeProxy.getChildren().

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getLength()` The number of nodes in the list.
    `org.w3c.dom.Node` | `item(int index)` Returns the `index`th item in the collection.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DTMChildIterNodeList

          public DTMChildIterNodeList(DTM parentDTM,
                                      int parentHandle)

      Public constructor: Create a NodeList to support DTMNodeProxy.getChildren(). Unfortunately AxisIterators and DTMIterators don't share an API, so I can't use the existing Axis.CHILD iterator. Rather than create Yet Another Class, let's set up a special case of this one.
      Parameters:
        `parentDTM` - The DTM containing this node
        `parentHandle` - DTM node-handle integer

  - ### Method Detail

    - #### item

          public org.w3c.dom.Node item(int index)

      Returns the `index`th item in the collection. If `index` is greater than or equal to the number of nodes in the list, this returns `null`.
      Specified by:
        `item` in interface `org.w3c.dom.NodeList`
      Overrides:
        `item` in class `DTMNodeListBase`
      Parameters:
        `index` - Index into the collection.
      Returns:
        The node at the `index`th position in the `NodeList`, or `null` if that is not a valid index.

    - #### getLength

          public int getLength()

      The number of nodes in the list. The range of valid child node indices is 0 to `length-1` inclusive.
      Specified by:
        `getLength` in interface `org.w3c.dom.NodeList`
      Overrides:
        `getLength` in class `DTMNodeListBase`

Copyright © 2023 Apache XML Project. All Rights Reserved.